#!/bin/sh

VER="0.1"
PROG=`basename $0`
SERVICEMENU=`echo $PROG | sed 's|.sh$|.desktop|'`
DATE=`date`
LOCAL="$HOSTNAME"
WEB="http://www.blackpanther.hu"
VERBOSE=1
PACKAGE_PATH="$2"
PACKAGE=`basename $2`
OUTPUT_DIR=`echo $PACKAGE_PATH | sed 's|.rpm$||'`

if [ -f "/etc/issue" ];then
   OS="&submit=Search+...&system="
   [ -n "`grep '[Mm][Aa][Nn][Dd][Rr]' /etc/issue`" ] && TYPE="mandrake" # Mandrake
   [ -n "`grep '[Ff][Ee][Dd][Oo][Rr][Aa]' /etc/issue`" ] && TYPE="fedora" # Fedora
   [ -n "`grep '[Ss][Uu][Ss][Ee]' /etc/issue`" ] && TYPE="suse" # SuSE
   if [ !  -n "$TYPE" ]; then
        TYPE=""
   else
      TYPE_TXT="( for System $TYPE )"
   fi
fi
RPMFIND="http://rpmfind.net/linux/rpm2html/search.php?query="

if [ ! $LANGUAGE ]; then
   LANGUAGE=`bash -c "source /etc/sysconfig/i18n && echo \\$LANGUAGE"`
fi
[ -n "`echo $LANGUAGE | grep 'hu_HU'`" ] &&  DESCRIPTION="Gyorsmen az RPM fjlok kezelshez."      
#[ -n "`echo $LANGUAGE | grep 'es_ES'`" ] &&  DESCRIPTION="Servicemenu, para integrar informacines del package en un fichero html, y extrae fecheros del package."
[ !  -n "$DESCRIPTION" ] &&  DESCRIPTION="Servicemenu to put the contents and info of package in to html file" 

RPM_CHANGELOG=`rpm -qp --changelog $PACKAGE_PATH`
RPM_P=`rpm -qp --provides $PACKAGE_PATH | sed -e 's|(| (|g' | awk '$1 != "(none)" { print "<a href=http://rpmfind.net/linux/rpm2html/search.php?query="$1">"$1"</a>"$2$3$34$5$6$7 }'`
RPM_R=`rpm -qp --requires $PACKAGE_PATH | sed 's|(| (|g' | awk '$1 != "(none)" { print "<a href=http://rpmfind.net/linux/rpm2html/search.php?query="$1">"$1"</a>"$2$3$3$4$5$6$7 }'`
QUERY='
<tr>
<td>
<em>Name:</em> %{NAME}<br>
<em>Version: </em>%{VERSION}<br>
<em>Release: </em>%{RELEASE}<br>
<em>Group: </em>%{GROUP}<br>
<em>Packager: </em>%{PACKAGER}<br>
<em>URL: </em><a href=%{URL}>%{URL}</a><br>
</td>
<td>
<em>Platforme: </em>%{PLATFORM}<br>
<em>Build Host: </em>%{BUILDHOST}<br>
<em>Arch: </em>%{ARCH}<br>
<em>License: </em>%{LICENSE}<br>
<em>Vendor: </em>%{VENDOR}<br>
<em>Build date: </em>%{BUILDTIME:date}<br>
</td>
</tr>
<tr>
<td colspan=2 rowspan=1>
<em>Summary: </em>%{SUMMARY}
</td>
</tr> 
<tr>
<td colspan=2 rowspan=1>
<em><u>Description:</u></em><br>
<pre>%{DESCRIPTION}</pre>
</td>
</tr>   
<tr>
<td colspan=2 rowspan=1 bgcolor=#dedede><a NAME=scripts>
<h2>Scripts:</h2>
</td>
</tr>
<tr>
<td colspan=2 rowspan=1>
<em><u>Script post-install:</u></em>
<pre>%{POSTIN}</pre>
<em><u>Script uninstall:</u></em>
<pre>%{POSTUN}</pre>
</td>
</tr>'

function HautPage {
cat <<EOF >> $RPM_HTML
<html>
<head>
<title>About: ${PACKAGE}</title>
<META NAME=GENERATOR CONTENT=${PROG} (Ver.${VER}) part of ${SERVICEMENU}>
<META NAME=CREATED CONTENT=${DATE}>
<META NAME=CHANGEDBY CONTENT=${LOCAL}>
<META NAME=DESCRIPTION CONTENT= ${DESCRIPTION}>
</head>
<body text=#646464 link=#0066dd vlink=#0066dd>
<table width=100% border=0>
<tbody>
<tr>
<td colspan=2 rowspan=1 bgcolor=#A4A4A4>
<P ALIGN=CENTER>| <a href="mailto:kbarcza@blackpanther.hu?subject=$SERVICEMENU $VER"> Contact </a> | <a href=http://www.blackpather.hu> About </a> | <a href=#scripts> Scripts </a> | <a href=#provides/requires> Provides/Requires </a> | <a href=#files> Files </a> | <a href=#changelog> Changelog </a> | <a href=#rpmfind> Rpmfind </a> |</P>



</td>
</tr>
<tr><td><br></td></tr>
<tr>
<td colspan=2 cellpadding=0 bgcolor=#dedede>
<h2> General Info <a href=${PACKAGE_PATH}>${PACKAGE}</a></h2>
</td>
</tr>
EOF
};

function QueryFormat {
rpm -qp --queryformat "$QUERY" "$PACKAGE_PATH" >> "$RPM_HTML"
};

function CorpsPage {
cat <<EOF >> $RPM_HTML
<tr>
<td colspan=2 rowspan=1 bgcolor=#dedede>
<h2>Provides and Requires:</h2>
</td>
</tr>
<tr>
<td colspan=2 rowspan=1><a NAME=provides/requires>
<em><u>Provides:</u></em>
<pre>${RPM_P}</pre>
</td>
</tr>
<tr>
<td colspan=2 rowspan=1>
<em><u>Requires:</u></em>
<pre>${RPM_R}</pre>
</td>
</tr>
<tr>
<td colspan=2 rowspan=1 bgcolor=#dedede><a NAME=files>
<h2>Files:</h2>
</td>
</tr>
<tr>
<td colspan=2 rowspan=1>
<pre>${RPM_FILES}</pre>
</td>
</tr>
EOF
};

function ChanPage {
cat <<EOF >> $RPM_HTML
<tr>
<td colspan=2 rowspan=1 bgcolor=#dedede><a NAME=changelog>
<h2>Changelog:</h2>
</td>
</tr>
<tr>
<td colspan=2 rowspan=1>
<pre>${RPM_CHANGELOG}</pre>
</td>
</tr>
EOF
};    

function BasPage {
NAME=`grep "<em>Name:</em>" $RPM_HTML | awk '{ print$2 }'| sed 's|<br>||g'`
cat <<EOF >> $RPM_HTML
<tr>
<td colspan=2 rowspan=1 bgcolor=#dedede><a NAME=rpmfind>
<h2>Search <a href=${RPMFIND}${NAME}${OS}${TYPE}>${NAME}</a> ${TYPE_TXT} witch <a href=http://rpmfind.net>RpmFind</a></h2>
</td>
</tr>
<tr><td><br></td></tr>
<tr>
<td colspan=2 rowspan=1 bgcolor=#A4A4A4>
<P ALIGN=CENTER>Generated by  <a href=${WEB}>${PROG} (Ver.${VER}) </a>part of<a href=${WEB}> ${SERVICEMENU}</a>, at ${DATE}</P>
</td>
</tr>
</tbody>
</table>
</html>
EOF
};



for ACTION in $1; do
   case "$ACTION" in
      --extract)
        if [ -f "$2" ] && [ -n "`echo $2 | grep '.rpm$'`" ]; then
	   RPM_FILES=`rpm -qlp $PACKAGE_PATH | sed -e 's|(| (|g' | awk '$1 != "(none)" { print "<a href=./"$1">"$1"</a>"$2$3$34$5$6$7 }'`
	   RPM_HTML="${OUTPUT_DIR}/${PACKAGE}.html"
	   [ -f "$RPM_HTML" ] && rm -f $RPM_HTML 
           [ ! -n" $DISPLAY" ] && echo -n "Extract ${PACKAGE} ..."
           mkdir -p $OUTPUT_DIR
           touch $RPM_HTML
           HautPage 
           QueryFormat 
           CorpsPage
           BasPage
           [ -n "$DISPLAY" ] && kfmclient newTab $RPM_HTML
           [ ! -n "$DISPLAY" ] && echo -n " in $RPM_HTML"
           cd $OUTPUT_DIR; rpm2cpio $DIR/$PACKAGE_PATH | cpio -idvd
	else
	   [ -n "$DISPLAY" ] && dcop kio_uiserver UIServer messageBox 0 5 "File $2 not package RPM" "Warnning" dummy dummy;
	   [ ! -n "$DISPLAY" ] && echo "File $2 not package RPM"
	fi   
	exit 0
	;;
	
      --forceinstall)
        if [ -f "$2" ] && [ -n "`echo $2 | grep '.rpm$'`" ]; then
	    `zenity --question --text "Biztos, hogy a ${PACKAGE} -t fggsgvizsglat nlkl akarod telepteni? \n
		-=: blackPanther OS Team :=-"` test $? -ne 0 && exit 1	
	    RPM_FILES=`rpm -e $NAME` |
	    zenity --progress --pulsate --auto-close 2>/dev/null
	   [ -f "$RPM_HTML" ] && rm -f $RPM_HTML 
           [ ! -n" $DISPLAY" ] && echo -n "UnInstall ${PACKAGE} ..."
           [ -n "$DISPLAY" ] && zenity --info --text "A '${PACKAGE}' eltvoltsa ksz"
           [ ! -n "$DISPLAY" ] && echo -n "Package force installed"
	else
	   [ -n "$DISPLAY" ] && dcop kio_uiserver UIServer messageBox 0 5 "File $2 not package RPM" "Warnning" dummy dummy;
	   [ ! -n "$DISPLAY" ] && echo "File $2 not package RPM"
	fi   
	exit 0
	;;

      --install)
	if [ -n "`echo $2 | grep '.src.rpm$'`" ]; then
	    zenity --error --text "Not used 'QuickRPM' to 'src.rpm'-files,
		 please use 'rpm -i ..' command in console"
	    exit 0
	fi
        
	if [ -f "$2" ] && [ -n "`echo $2 | grep '.rpm$'`" ]; then
	    RPM_FILES=`gurpmi $PACKAGE_PATH`
           [ ! -n" $DISPLAY" ] && echo -n "Install ${PACKAGE} ..."
           [ -n "$DISPLAY" ] && zenity --info --text "A '${PACKAGE}' sikeresen teleptve lett."
           [ ! -n "$DISPLAY" ] && echo -n "Package installed"
	else
	   [ -n "$DISPLAY" ] && dcop kio_uiserver UIServer messageBox 0 5 "File $2 not package RPM" "Warnning" dummy dummy;
	   [ ! -n "$DISPLAY" ] && echo "File $2 not package RPM"
	fi   
	exit 0
	;;

      --uninstall)
        if [ -f "$2" ] && [ -n "`echo $2 | grep '.rpm$'`" ]; then
	    RPM_FILES=`rpm -e ${NAME}` |
	    zenity --progress --pulsate --auto-close 2>/dev/null
	   [ -f "$RPM_HTML" ] && rm -f $RPM_HTML 
           [ ! -n" $DISPLAY" ] && echo -n "ForceInstall ${PACKAGE} ..."
           [ -n "$DISPLAY" ] && zenity --info --text "A '${PACKAGE}'teleptve lett a fggsgek ellenrzse nlkl,
	   ha a program hasznlatval gondok addnak felttlenl fel kell oldani a fggsgeket"
           [ ! -n "$DISPLAY" ] && echo -n "Package force installed"
	else
	   [ -n "$DISPLAY" ] && dcop kio_uiserver UIServer messageBox 0 5 "File $2 not package RPM" "Warnning" dummy dummy;
	   [ ! -n "$DISPLAY" ] && echo "File $2 not package RPM"
	fi   
	exit 0
	;;

      --forceinstall)
        if [ -f "$2" ] && [ -n "`echo $2 | grep '.rpm$'`" ]; then
	    `zenity --question --text "Biztos, hogy a ${PACKAGE} -t fggsgvizsglat nlkl akarod telepteni? \n
		-=: blackPanther OS Team :=-"` test $? -ne 0 && exit 1	
	    RPM_FILES=`rpm -U $PACKAGE_PATH --nodeps` |
	    zenity --progress --pulsate --auto-close 2>/dev/null
	   [ -f "$RPM_HTML" ] && rm -f $RPM_HTML 
           [ ! -n" $DISPLAY" ] && echo -n "ForceInstall ${PACKAGE} ..."
           [ -n "$DISPLAY" ] && zenity --info --text "A '${PACKAGE}'teleptve lett a fggsgek ellenrzse nlkl"
           [ ! -n "$DISPLAY" ] && echo -n "Package force installed"
	else
	   [ -n "$DISPLAY" ] && dcop kio_uiserver UIServer messageBox 0 5 "File $2 not package RPM" "Warnning" dummy dummy;
	   [ ! -n "$DISPLAY" ] && echo "File $2 not package RPM"
	fi   
	exit 0
	;;
	
	--updates)
	   # Aller sur le site de Manage rpm:
	   if [ -n "`ping -c 1 www.matav.hu | grep 'PING www.matav.hu'`" ]; then 
	      kfmclient openURL http://www.blackpanther.hu/updates
	   else 
	      [ -n "$DISPLAY" ] && dcop kio_uiserver UIServer messageBox 0 5 "Net connection not found" "Warnning" dummy dummy;
	      [ ! -n "$DISPLAY" ] && echo "bP site not found"
	   fi
	   exit 0
	   ;;
	   
	--search)
	   # recherche d'un package sur rpmfind:
	   if [ -n "`ping www.rpmfind.net -c 1 | grep 'PING www.rpmfind.net'`" ]; then 
	      NAME=`rpm -qip $2 | grep Name | awk '{print $3}'`   
	      kfmclient newTab ${RPMFIND}${NAME}${OS}${TYPE}
	   else 
	      [ -n "$DISPLAY" ] && dcop kio_uiserver UIServer messageBox 0 5 "www.rpmfind.net not found" "Warnning" dummy dummy;
	       [ ! -n "$DISPLAY" ] && echo "www.rpmfind.net not found"
	   fi
	   exit 0
	  ;;
	  
	  --info)
	  # Construction de la page html avec les infos:
	  if [ -f "$2" ] && [ -n "`echo $2 | grep '.rpm$'`" ]; then
	     RPM_HTML="/tmp/${PACKAGE}.html"
	     RPM_FILES=`rpm -qlp $PACKAGE_PATH`
	      [ -f "$RPM_HTML" ] && rm -f /tmp/$RPM_HTML 
              [ ! -n" $DISPLAY" ] && echo -n "Info ${PACKAGE} ..."
              touch $RPM_HTML
              HautPage 
              QueryFormat 
              CorpsPage
	      ChanPage
              BasPage
              [ -n "$DISPLAY" ] && kfmclient openURL $RPM_HTML
              [ ! -n "$DISPLAY" ] && echo -n " in $RPM_HTML"
	      [ -f "$RPM_HTML" ] && rm -f $RPM_HTML /tmp/$RPM_HTML
           else
	      [ -n "$DISPLAY" ] && dcop kio_uiserver UIServer messageBox 0 5 "File $2 not package RPM" "Warnning" dummy dummy;
	      [ ! -n "$DISPLAY" ] && echo "File $2 not package RPM"
	   fi   
	exit 0   
	;;            
	
	--changelog)
	  # Construction de la page html avec les infos:
	  if [ -f "$2" ] && [ -n "`echo $2 | grep '.rpm$'`" ]; then
	     RPM_HTML="${PACKAGE}.html"
	     RPM_FILES=`rpm -qp --changelog $PACKAGE_PATH`
	      [ -f "$RPM_HTML" ] && rm -f $RPM_HTML 
              [ ! -n" $DISPLAY" ] && echo -n "Changelog ${PACKAGE} ..."
              touch $RPM_HTML  
              ChanPage
              BasPage
              [ -n "$DISPLAY" ] && kfmclient openURL $RPM_HTML
	      
              [ ! -n "$DISPLAY" ] && echo -n " in $RPM_HTML"
           else
	      [ -n "$DISPLAY" ] && dcop kio_uiserver UIServer messageBox 0 5 "File $2 not package RPM" "Warnning" dummy dummy;
	      [ ! -n "$DISPLAY" ] && echo "File $2 not package RPM"
	   fi   
	exit 0   
	;;            

	*)
	   [ -n "$DISPLAY" ] && dcop kio_uiserver UIServer messageBox 0 5 "$PROG too few arguments" "Warnning"  dummy dummy;
	   [ ! -n "$DISPLAY" ] && echo "www.rpmfind.net not found"
	   exit 0
	  ;;        

      esac
  
done

